@echo off
echo.
rem Q2MM%Q2id_ver% - (non-QDAT)/indexing/LePage script for MMap (for Crysfire 2002 [TPas])
rem        (includes checks for sort program and empty input files)
rem        (Uses _CFhome & CSORT [direct runs not applicable], XP-compatible)
set _Pname=MMAP
set _Pver=MMAP9.45.03
set _ID=MM
set _Sdate=18Apr03
rem set _Dsp=(none)
rem Supported file types: GM
rem (Pre-computed within CFMAIN - sort, etc, and display time only)
rem
if (%1) == () goto usage
echo Q2%_ID%%Q2id_ver% - Carries out post-processing summary sort/display/LePage actions
echo following a run of the MM=MMap command in CFMAIN within Crysfire
echo.
echo R.Shirley, %_Sdate%
echo.
rem set _Dspn=(none)
set _Dset=%1

rem _CFhome is now usually set by Crysfire, etc., before this is called
if not (%_CFhome%) == () goto SetIndexEdit
rem _CFhome hasn't been set ... let's see if we can do it now
call CF_home
if not (%_CFhome%) == () goto SetIndexEdit
echo ** Q2%_ID% was unable to establish the Crysfire home directory from CF_home.bat
echo (Please check that there's a valid copy of CF_home.bat on the execution path)
echo.
goto end

:SetIndexEdit
if not (%INDEXEDIT%) == () goto IndexEditSet
rem Try to sense whether we're running on W95, and if so set default output
rem viewer to WordPad (i.e. "Write") instead of MS EDIT.  (Done here as well
rem as in Crysfire.bat, in case this is run directly)
if not (%winbootdir%) == () set INDEXEDIT=Write
if %COMSPEC% == C:\WINDOWS\COMMAND.COM set INDEXEDIT=Write
:IndexEditSet

rem Carry out systematic file renaming (not applicable to MMap post-processing)
:ren_log
:ren_sum

:upd_log
rem Not applicable to MMap - the log is updated directly by CFMAIN's MM command
rem (the backup in .LGK remains unchanged)

:upd_app
rem Unnecessary to append the run-summary .%_ID%M to dataset-summary .SUM, since
rem .SUM is updated directly by CFMAIN's MM command (the backup in .SMK remains
rem unchanged).  But it is still necessary to sort the updated dataset-summary
rem into descending order of I20 & Merit and to update the V/V1 ratios based on
rem the volume now in record one
%_CFhome%\DelifNul %_Dset%.SUM
if not exist %_Dset%.SUM echo ** Can't find the main summary file %_Dset%.SUM, so can't sort or process it **
if not exist %_Dset%.SUM goto end

:chk_sort
rem Skip if already verified and prepared the sort utility...
if not (%_Csrtst%) == () goto run_VRAT
rem ...else establish which sort program to use

rem But, for robustness, simply specify CSORT rather than test for a sort program
set _Csrt=%_CFhome%\CSORT -r
set _Csrtst=Yes
goto run_VRAT

echo.
echo Checking that there's a working SORT program on the execution PATH
echo.
set _Csrt=
if exist _Csrtb del _Csrtb
echo abc > _Csrta
rem Try MS SORT
SORT /R <_Csrta >_Csrtb
if exist _Csrtb set _Csrt=SORT /R
rem Also need to make a _Csrtst var, since Win/XP doesn't allow
rem spaces in the test strings used for "if ... = ..." tests
if exist _Csrtb set _Csrtst=Yes
if not (%_Csrtst%) == () goto run_VRAT
rem Nope, so try CSORT
rem CSORT parameter must be "-r" and not "-R", or usage will also be displayed
%_CFhome%\CSORT -r <_Csrta >_Csrtb
if exist _Csrtb set _Csrt=%_CFhome%\CSORT -r
if exist _Csrtb set _Csrtst=Yes
rem if not (%_Csrtst%) == () goto run_VRAT
if exist _Csrta del _Csrta
if exist _Csrtb del _Csrtb
echo  ** Warning **  Crysfire has not found a working SORT program on this system.
echo.
echo  If you proceed, you will still be able to run Crysfire commands and launch
echo  indexing runs, but Crysfire will be unable to display any sorted summary files
echo  or run the LePage program to produce a revised summary of the reduced cells
echo.
echo  To exit, press ENTER, then type QU (and ENTER) at the Crysfire command prompt
echo.
echo  This shouldn't be able to happen if Crysfire has been installed correctly,
echo  since the Crysfire 2002 distribution includes a backup sort utility CSORT.
echo  Check that CSORT.EXE has been copied correctly to your Crysfire directory
echo.
pause

:CFstart
if exist _Csrta del _Csrta
if exist _Csrtb del _Csrtb

:run_VRAT
rem (Already checked that %_Dset%.SUM exists)
if not (%_Csrtst%) == () %_Csrt% <%_Dset%.SUM >%_Dset%.$$2
rem Use program VRATIO to update the V/V1 ratios in the sorted summary
%_CFhome%\DelifNul %_Dset%.$$2
if not exist %_Dset%.$$2 goto add_head
%_CFhome%\VRATIO %_Dset%.$$2 %_Dset%.SUM >nul
del %_Dset%.$$? >nul
:add_head
if exist %_Dset%.SMH del %_Dset%.SMH >nul
rem Use program QHEAD to generate headings file HEADINGS.SUM, so that
rem HEADINGS.SUM need not be copied beforehand into the current directory
%_CFhome%\QHEAD >nul
rem HEADINGS.SUM should now be present, but its existence tests have been
rem kept anyway, in case of problems
if exist HEADINGS.SUM copy HEADINGS.SUM+%_Dset%.SUM %_Dset%.SMH >nul

:disp_sht
rem Not applicable to MMap - all relevant map output, etc., has already been
rem displayed by CFMAIN's MM command
%_CFhome%\DelifNul %_Dset%.SUM
if exist %_Dset%.SUM goto if_sort
echo ** No summary files to display, so this analysis can't be taken further
echo.
pause
goto end

:if_sort
if not (%_Csrtst%) == () goto cont_smh
echo.
echo ** Can't proceed to display sorted summary files, etc., without a
echo ** working sort program, so must terminate this analysis here
echo.
pause
goto end

:cont_smh
%_CFhome%\DelifNul %_Dset%.SMH
if exist %_Dset%.SMH goto disp_smh
if exist HEADINGS.SUM goto disp_cont
echo Don't interrupt the run to do it now, but note for future reference that
echo if you make sure that the program QHEAD is present in the Crysfire directory,
echo your summary files will then be displayed with an explanatory heading.
echo.
pause
:disp_cont
%_CFhome%\DelifNul %_Dset%.SUM
if exist %_Dset%.SUM goto disp_smh
echo Can't find summary file %_Dset%.SMH or .SUM to display next in the editor,
echo so will have to end the run now, and leave you to check that for yourself
goto end

:disp_smh
rem We can now delete HEADINGS.SUM to reduce the file clutter (it was retained
rem only as a flag to disarm the above QHEAD warning, if present)
if exist HEADINGS.SUM del HEADINGS.SUM >nul
echo The sorted summary file of all indexing solutions found so far by the
echo Crysfire system for dataset %_Dset% will now be displayed
pause
set INDXED=%INDEXEDIT%
if (%INDXED%) == () set INDXED=edit
set _EXT=SUM
if exist %_Dset%.SMH set _EXT=SMH
%INDXED% %_Dset%.%_EXT%
set _EXT=

%_CFhome%\DelifNul %_Dset%.SUM
if exist %_Dset%.SUM goto run_clp
:runclp_err
echo Can't find summary file %_Dset%.SUM, so can't do a Le Page reduced-cell
echo analysis - must terminate these analyses and return to the main Crysfire prompt
echo.
pause
goto end

:run_clp
echo An adapted version of Ton Spek's Le Page reduced-cell program will now run
echo (with acknowledgements to Ton Spek [Utrecht] and A. Meetsma [Groningen]).
echo This will process each solution in the summary file, giving its Le Page
echo reduced cell, a proposed conventional cell and additional items of lattice
echo and symmetry information.
echo.
echo Its main output file will be written to disk and will include the Niggli
echo reduced cell for each solution, with its corresponding sub-cell and
echo super-cell analyses.  This is not displayed automatically as it can be
echo bulky and requires experience to interpret.
echo.
echo Instead a revised summary file will be displayed, listing the various
echo solutions with their reduced cell properties.
echo.
if exist %_Dset%.COK del %_Dset%.COK
if exist %_Dset%.CLO ren %_Dset%.CLO %_Dset%.COK
if exist %_Dset%.CMK del %_Dset%.CMK
if exist %_Dset%.CLM ren %_Dset%.CLM %_Dset%.CMK
%_CFhome%\CLEPAGE %_Dset% AUTO >nul
%_CFhome%\DelifNul %_Dset%.CLO
rem As %_Dset%.CLO is no longer displayed, it's not worth checking for it
rem if exist %_Dset%.CLO goto disp_clo
goto chk_clm

:dspclo_err
rem dspclo_err can't now be reached - R.Shirley, 16May02
echo Can't find Le Page output file %_Dset%.CLO, so will have to terminate
echo these analyses now, and return to the main Crysfire prompt
echo.
pause
goto end

:disp_clo
rem Main Le Page output file no longer displayed (too bulky and confusing)
rem so the next 3 lines have been commented out - R.Shirley, 23Apr02
rem echo The Le Page %_Dspn% output file will now be displayed.
rem echo.
rem pause
rem %INDXED% %_Dset%.CLO

:chk_clm
%_CFhome%\DelifNul %_Dset%.CLM
if exist %_Dset%.CLM goto disp_clm
:dspclm_err
echo Can't find Le Page summary file %_Dset%.CLM to display next in the editor,
echo so will have to end the run now, and leave you to check that for yourself
goto end

:disp_clm
echo The Le Page summary file will now be displayed.
echo.
pause
%INDXED% %_Dset%.CLM
goto end

:failed
rem Not applicable to MMap - the run has already taken place in the MM command
rem within CFMAIN

:usage
echo Q2%_ID%%Q2id_ver% - Carries out post-processing summary sort/display/Le Page actions
echo following a run of the MM=MMap command in CFMAIN within Crysfire
echo Typical run time:  a few seconds for sorting, processing and display only
echo.
echo usage    Q2%_ID%%Q2id_ver% {datafile}
echo.
echo          where {datafile} is the base name of the %%1.SUM summary file
echo                (without its .SUM extension)
echo.
echo   The same {datafile} name is used to identify all files in the run:
echo.
echo   The solutions log and summary are assumed to have already been appended
echo   to the log and summary files for that dataset: {datafile}.LOG and
echo   {datafile}.SUM respectively.
echo.
echo   {datafile}.SUM is sorted into descending order of I20 and Merit.
echo   (The minimum levels for inclusion vary for different indexing programs,
echo   but for MMap are typically I20 above 15 and Merit above 5)
echo.
echo   The sorted solutions summary is then displayed using the editor specified
echo   in environmental variable INDEXEDIT (default: WordPad[Windows],EDIT[DOS]).
echo.
pause
echo   A Le Page reduced-cell analysis is then performed on all solutions found
echo   so far (taken in descending order as described above), courtesy of
echo   Ton Spek and A.Meetsma, and a revised summary file displayed including
echo   reduced cell information.  Since the main Le Page output file can be bulky
echo   and rather technical, it is saved to disk without being displayed.
echo.
echo   Thus the following files provide a record of all runs for this dataset,
echo   after updating with the current run as described above:
echo.
echo      dataset solutions-log         = {datafile}.LOG
echo      dataset solutions-summary     = {datafile}.SUM  (sorted)
echo      dataset solutions-display     = {datafile}.SMH  (headed summary)
echo      Le Page reduced-cell analysis = {datafile}.CLO  (in sorted order)
echo      Le Page reduced-cell summary  = {datafile}.CLM  (headed summary)
echo.
echo      old dataset solutions-log     = {datafile}.LGK  (backup)
echo      old dataset solutions-summary = {datafile}.SMK  (backup)
echo      old Le Page analysis          = {datafile}.COK  (backup)
echo      old Le Page summary           = {datafile}.CMK  (backup)
echo.
echo   R.Shirley, %_Sdate%
echo.

:end
set INDXED=
set _Dset=
rem set _Dspn=
rem set _Dsp=
set _Sdate=
set _ID=
set _Pver=
set _Pname=
